Attribute VB_Name = "module1"
'  A suite of programs for the analysis of chants.
'  Copyright (C) 2000-2004 Ruth M. Ripley
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
Option Base 1
Option Explicit
Private Declare Function SetBkMode Lib "gdi32" _
(ByVal hDC As Long, ByVal nBkMode As Long) As Long
Private iBkMode As Long

Private Const TRANSPARENT = 1
Private Const OPAQUE = 2
Public Type Note
  NoteNo As Integer
  RelPos As Integer
  Long As Integer
  Pitch As Integer
End Type
Public Type Neume
  NeumeNo As Integer
  Name As Integer
  DetailsType As Integer
  Details As Variant
  PitchDetType As Integer
  PitchDetails As String
  Liq As Boolean
  Quil As Boolean
  NumNotes As Integer
  Note() As Note
End Type
Public Type Syllable
    SyllableNo As Integer
    text As String
    Verse As Boolean
    Phrase As Boolean
    NumNeumes As Integer
    Neume() As Neume
End Type
Public Type neum
    names() As Long
    NmSyl() As Integer
    Nseq() As Integer
End Type
Public Type Notes
    RelPos() As Integer
    NmSyl() As Integer
    NmNeume() As Integer
    Nseq() As Integer
End Type
Public Type Chant
  FullName As String
  ShortName As String
  NumSyllables As Integer
  Syllable() As Syllable
  neum As neum
  Notes As Notes
  lenv() As Long
  clenv() As Integer
  nnv() As Long
  cnv() As Long
  nonv() As Integer
  cnonv() As Integer
  Arrays As Boolean
End Type
Public Type Phrase
    PhraseNo As Integer
    NumSyllables As Integer
    Syllable() As Syllable
    NeumOffs As Long
End Type
Public Type Verse
    VerseNo As Integer
    NumPhrases As Integer
    Phrase() As Phrase
End Type
Public Type Chant2
    FullName As String
    ShortName As String
    NumVerses As Integer
    Verse() As Verse
    NeumOffs() As Long
End Type
Public NumDetails() As Integer
Public Details() As String, fontindex() As Integer
Public DetInst() As Integer
Public Template() As Neume
Public NumNeumes As Integer
Public RelPosTable(0 To 9) As String
Public LongTable(0 To 2) As String
Public NeumeTable() As String
Public Chants() As Chant
Public NumChants As Integer
Public ThisChant As Integer, picns() As Integer, picnn() As Integer
Public picx2() As Single, picy2() As Single, pixsels() As Boolean
Public picn() As Neume, pixsel() As Boolean, picx() As Single, picy() As Single
Public myneumes() As Neume, myneume1 As Integer, myneume2 As Integer, neumepatt As Boolean
Public home_dir As String, app_dir As String, startSyl As Integer, endSyl As Integer
Public thisfilename As String, picxs() As Single, picys() As Single, picj() As Integer
Public chantfont As String, isPicx As Boolean, thisneumefile As String

Public Type vphr
    Chant As Variant
    Verse As Integer
    Seqno As Integer
    Type As String * 1
End Type
Public Enum general
MAXHEIGHT = 80000
PAPERHEIGHT = 16848 ' A4 - 1440 per inch
End Enum
Public Sub change_ds(DS As Chant2, ThisChant As Integer)
Dim i As Integer, v As Integer, p As Integer, s As Integer, tmp As Integer
i = 1
v = 0
p = 0
s = 0
DS.FullName = Chants(ThisChant).FullName
DS.ShortName = Chants(ThisChant).ShortName
ReDim DS.Verse(1000)
Do While i <= Chants(ThisChant).NumSyllables
    v = v + 1
    ReDim DS.Verse(v).Phrase(1000)
    Do
        p = p + 1
        ReDim DS.Verse(v).Phrase(p).Syllable(1000)
        Do
            s = s + 1
            DS.Verse(v).Phrase(p).Syllable(s) = _
                Chants(ThisChant).Syllable(i)
            i = i + 1
            If i > Chants(ThisChant).NumSyllables Then
                Exit Do
            End If
        Loop Until Chants(ThisChant).Syllable(i).Phrase
        DS.Verse(v).Phrase(p).NumSyllables = s
        ReDim Preserve DS.Verse(v).Phrase(p).Syllable(s)
        s = 0
        If i > Chants(ThisChant).NumSyllables Then
            Exit Do
        End If
    Loop Until Chants(ThisChant).Syllable(i).Verse
    DS.Verse(v).NumPhrases = p
    ReDim Preserve DS.Verse(v).Phrase(p)
    p = 0
Loop
DS.NumVerses = v
ReDim Preserve DS.Verse(v)
' calc offsets of phrases in terms of neums
tmp = 0
i = 0
ReDim DS.NeumOffs(1000)
For v = 1 To DS.NumVerses
    For p = 1 To DS.Verse(v).NumPhrases
        DS.Verse(v).Phrase(p).NeumOffs = tmp
        i = i + 1
        DS.NeumOffs(i) = tmp
        For s = 1 To DS.Verse(v).Phrase(p).NumSyllables
            tmp = tmp + DS.Verse(v).Phrase(p).Syllable(s).NumNeumes
        Next s
    Next p
Next v
ReDim Preserve DS.NeumOffs(i)
End Sub
Public Sub getDetails(n As Neume, s As String, p As String)
Dim i As Integer
Select Case n.DetailsType
    Case 0
        Select Case n.Details
            Case 0
                s = ""
            Case 1
                s = "c"
            Case 2
                s = "t"
            Case 3
                s = "ep"
            Case 4
                s = "L"
            Case Else
                s = Details(n.Name, n.Details - 4)
        End Select
    Case 1
        p = n.Details
        s = ""
        For i = 1 To Len(p)
            If Mid(p, i, 1) < 0 Or Mid(p, i, 1) > 9 Then
                If Mid(p, i + 1, 1) > 0 And Mid(p, i + 1, 1) < 10 Then
                    s = s + Mid(p, i, 1)
                End If
            Else
                s = s + Mid(p, i, 1)
            End If
        Next i
    Case Else
        s = n.Details
    End Select
p = n.PitchDetails
'If Len(p) = 2 Then
 '   p = Left(p, 1)
'End If
If Not n.NumNotes = Template(n.Name).NumNotes Then
    p = p + "*"
End If
End Sub

Public Sub get_screen_neumes(OK As Boolean)
Dim i As Integer, k As Integer
'get string from pixsel array (should correspond to highlighted screen
k = 0
ReDim myneumes(1 To UBound(picn) + 1)
For i = 1 To UBound(picn)
    If pixsel(i) Then
        k = k + 1
        myneumes(k) = picn(i)
    End If
Next i
If k = 0 Then
    MsgBox "No neumes highlighted"
    OK = False
End If
If k > 0 Then
    ReDim Preserve myneumes(1 To k)
    OK = True
End If
End Sub
Public Sub make_arrays(ThisChant As Integer)
Dim i As Integer, j As Integer, k As Integer, kk As Integer, l As Integer, startv As Integer
Dim neum(1 To 1000) As Long, NmSyl(1 To 1000) As Integer, kkk As Integer
Dim Nseq(1 To 1000) As Integer, Nnseq(1 To 2000) As Integer, Nnsyl(1 To 2000) As Integer
Dim Notes(1 To 2000) As Integer, Nmseq(1 To 2000) As Integer
Dim nv As Integer, lenv() As Long, nopv() As Integer, kp As Integer
Dim cnv() As Long, nnv() As Long, nonv() As Integer, cnonv() As Integer
Dim clenv() As Integer
'find number of verses
nv = 0
For i = 1 To Chants(ThisChant).NumSyllables
    If Chants(ThisChant).Syllable(i).Verse Then
        nv = nv + 1
    End If
Next i

'redim arrays
ReDim lenv(0 To nv)
ReDim nnv(0 To nv)
ReDim nonv(0 To nv)
ReDim nopv(0 To nv)
'create arrays of phrases per verse, syllables per verse (lenv),
'number of neumes per verse (nnv), notes per verse (nonv)
j = 0
startv = 1
k = 1
kk = 1
kp = 1
For i = 1 To Chants(ThisChant).NumSyllables
    If Chants(ThisChant).Syllable(i).Verse Then
        lenv(j) = i - startv
        nnv(j) = k - 1
        nonv(j) = kk - 1
        nopv(j) = kp - 1
        startv = i
        j = j + 1
        k = 1
        kk = 1
    End If
    If Chants(ThisChant).Syllable(i).Phrase Then
        kp = kp + 1
    End If
    k = k + Chants(ThisChant).Syllable(i).NumNeumes
    For kkk = 1 To Chants(ThisChant).Syllable(i).NumNeumes
        kk = kk + Chants(ThisChant).Syllable(i).Neume(kkk).NumNotes
    Next kkk
Next i
nonv(j) = kk - 1
lenv(j) = Chants(ThisChant).NumSyllables + 1 - startv
nnv(j) = k - 1
nopv(j) = kp - 1
'cumulative neumes per verse (cnv), and notes per verse (cnonv)
ReDim cnv(0 To nv)
ReDim clenv(0 To nv)
ReDim cnonv(0 To nv)
cnv(0) = 0
cnonv(0) = 0
clenv(0) = 0
For i = 1 To nv
    cnv(i) = cnv(i - 1) + nnv(i)
    cnonv(i) = cnonv(i - 1) + nonv(i)
    clenv(i) = clenv(i - 1) + lenv(i)
Next i
With Chants(ThisChant)
.cnonv = cnonv
.cnv = cnv
.lenv = lenv
.nnv = nnv
.nonv = nonv
.clenv = clenv
End With
'create arrays  neumes (neum), nmsyl (number of syllable), num of neumes in syllable (nsyl)
'also notes similarly
kk = 1
k = 1
For i = 1 To Chants(ThisChant).NumSyllables
    For l = 1 To Chants(ThisChant).Syllable(i).NumNeumes
        neum(kk) = Chants(ThisChant).Syllable(i).Neume(l).Name
        NmSyl(kk) = i
        Nseq(kk) = l
        kk = kk + 1
        For j = 1 To Chants(ThisChant).Syllable(i).Neume(l).NumNotes
            Nnsyl(k) = i
            Nnseq(k) = j
            Nmseq(k) = l
            Notes(k) = Chants(ThisChant).Syllable(i).Neume(l).Note(j).RelPos
            k = k + 1
        Next j
    Next l
Next i
If kk > 1 Then
    ' copy to part of chant object
    ReDim Chants(ThisChant).neum.names(1 To kk - 1)
    ReDim Chants(ThisChant).neum.NmSyl(1 To kk - 1)
    ReDim Chants(ThisChant).neum.Nseq(1 To kk - 1)
    For i = 1 To kk - 1
        Chants(ThisChant).neum.names(i) = neum(i)
        Chants(ThisChant).neum.NmSyl(i) = NmSyl(i)
        Chants(ThisChant).neum.Nseq(i) = Nseq(i)
    Next i
    If k > 1 Then
        ReDim Chants(ThisChant).Notes.RelPos(1 To k - 1)
        ReDim Chants(ThisChant).Notes.NmNeume(1 To k - 1)
        ReDim Chants(ThisChant).Notes.NmSyl(1 To k - 1)
        ReDim Chants(ThisChant).Notes.Nseq(1 To k - 1)
        For i = 1 To k - 1
            Chants(ThisChant).Notes.RelPos(i) = Notes(i)
            Chants(ThisChant).Notes.NmNeume(i) = Nmseq(i)
            Chants(ThisChant).Notes.NmSyl(i) = Nnsyl(i)
            Chants(ThisChant).Notes.Nseq(i) = Nnseq(i)
        Next i
    End If
End If
End Sub
Public Function Max(a, b)
    If a >= b Then
        Max = a
    Else
        Max = b
    End If
End Function

Public Function Min(a, b)
    If a > b Then
        Min = b
    Else
        Min = a
    End If
End Function
Public Sub nextPage(forw As Boolean)
Dim i As Integer
'Debug.Print startSyl, endSyl
If forw Then
    startSyl = endSyl + 1
    endSyl = endSyl + 30
    ' see where the verse ends are nearby and adjust endsyl if required
    With Chants(ThisChant)
        For i = 1 To UBound(.clenv)
            If endSyl > .clenv(i - 1) And endSyl <= .clenv(i) Then
                Exit For
            End If
        Next i
        ' i is verse of endsyl
        If endSyl - .clenv(i - 1) < 10 Or i > UBound(.clenv) Then
            endSyl = .clenv(i - 1)
        ElseIf .clenv(i) - endSyl < 10 Then
            endSyl = .clenv(i)
        End If
    End With
Else
    endSyl = startSyl - 1
    startSyl = endSyl - 30 + 1
    ' examine ends of verse nearby and adjust startsyl if required
      With Chants(ThisChant)
        For i = 1 To UBound(.clenv)
            If startSyl > .clenv(i - 1) And startSyl <= .clenv(i) Then
                Exit For
            End If
        Next i
        ' i is verse of startsyl
        If startSyl - .clenv(i - 1) < 10 Then
            startSyl = .clenv(i - 1) + 1
        ElseIf .clenv(i) - startSyl < 10 Then
            startSyl = .clenv(i) + 1
        End If
    End With
End If
If endSyl > Chants(ThisChant).NumSyllables Then
    endSyl = Chants(ThisChant).NumSyllables
End If
'Debug.Print startSyl, endSyl, i, Chants(ThisChant).clenv(i - 1), Chants(ThisChant).clenv(i)
End Sub

Public Sub neume_load()
Dim RelPosStr As String * 20
Dim i As Integer, ii As Integer, j As Integer, k As Integer
Dim fn As String, mypos As String
On Error GoTo errhandle1
Call Logfile(CurDir)
Open "neumes.dat" For Input As #1
thisneumefile = app_dir + "\neumes.dat"
GoTo gotfile
errhandle1:
common.CommonDialog1.InitDir = home_dir
common.CommonDialog1.Filter = "Neume files (*.dat)|*.dat|Any files|*.*"
common.CommonDialog1.ShowOpen
common.CommonDialog1.CancelError = True
Open common.CommonDialog1.FileName For Input As #1
thisneumefile = common.CommonDialog1.FileName
gotfile:
    Input #1, NumNeumes, chantfont
    ReDim Template(1 To NumNeumes)
    ReDim NeumeTable(0 To NumNeumes)
    NeumeTable(0) = ""
    ReDim NumDetails(1 To NumNeumes)
    ReDim Details(0 To NumNeumes, 0 To 15)
    ReDim DetInst(1 To NumNeumes, 1 To 15, 1 To 10)
    ReDim fontindex(1 To NumNeumes, -2 To 20)
    Details(0, 0) = ""
    For i = 1 To NumNeumes
        Template(i).Name = i
        Template(i).Liq = False
        Input #1, NeumeTable(i), NumDetails(i), Template(i).NumNotes
        For ii = -2 To 4 + NumDetails(i)
            Input #1, fontindex(i, ii)
        Next ii
        Input #1, RelPosStr
        ReDim Template(i).Note(1 To Template(i).NumNotes)
        For j = 1 To Template(i).NumNotes
            mypos = Mid(RelPosStr, 2 * (j - 1) + 1, 1)
            Template(i).Note(j).RelPos = InStr(1, "?+)=)-", mypos) - 1
        Next
        Details(i, 0) = ""
        For j = 1 To NumDetails(i)
            Input #1, Details(i, j), RelPosStr
            For k = 1 To Template(i).NumNotes
                DetInst(i, j, k) = Mid(RelPosStr, 2 * (k - 1) + 1, 1)
            Next
        Next
    Next
    Close #1
    RelPosTable(1) = "+"
    RelPosTable(2) = "?+"
    RelPosTable(0) = "?"
    RelPosTable(4) = "?-"
    RelPosTable(5) = "-"
    RelPosTable(3) = "="
    RelPosTable(6) = "++"
    RelPosTable(7) = "--"
    RelPosTable(8) = ".5+"
    RelPosTable(9) = ".5-"
    LongTable(0) = "Normal"
    LongTable(1) = "Long"
    LongTable(2) = "Short"
    On Error GoTo 0
    ChDir app_dir
    Exit Sub
Errhandler:
  '  If Err.Number <> cdlCancel Then
        Err.Raise Err.Number
   ' End If
    ChDir app_dir
End Sub


Public Sub Open_Chant()
Dim Found As Boolean, neumstr As String, i As Integer
Dim newNumChants As Integer, ii As Integer, j As Integer
Dim k As Integer, kk As Integer, pitchstr As String, ipos As Integer
On Error GoTo Errhandler
Call Logfile("open " + home_dir)
common.CommonDialog1.InitDir = home_dir
If NumChants > 0 Then
    If MsgBox("Do you want to retain chants already loaded?", vbYesNoCancel) = vbNo Then
        NumChants = 0
    End If
End If
common.CommonDialog1.Filter = "Chant files (*.cht)|*.cht|Any files|*.*"
common.CommonDialog1.ShowOpen
common.CommonDialog1.CancelError = True
Open common.CommonDialog1.FileName For Input As #1
thisfilename = common.CommonDialog1.FileName
Input #1, newNumChants
ReDim Preserve Chants(1 To NumChants + newNumChants)
For i = NumChants + 1 To NumChants + newNumChants
    Input #1, Chants(i).FullName
    Input #1, Chants(i).ShortName
    Input #1, Chants(i).NumSyllables
        ReDim Chants(i).Syllable(1 To Chants(i).NumSyllables)
        For ii = 1 To Chants(i).NumSyllables
            Chants(i).Syllable(ii).SyllableNo = ii
            Input #1, Chants(i).Syllable(ii).text
            Input #1, Chants(i).Syllable(ii).Verse
            Input #1, Chants(i).Syllable(ii).Phrase
            Input #1, Chants(i).Syllable(ii).NumNeumes
            If Chants(i).Syllable(ii).NumNeumes > 0 Then
                ReDim Chants(i).Syllable(ii).Neume(1 To _
                    Chants(i).Syllable(ii).NumNeumes)
                For j = 1 To Chants(i).Syllable(ii).NumNeumes
                    Input #1, neumstr
                    Found = False
                    For k = 1 To NumNeumes
                        If neumstr = NeumeTable(k) Then
                            Chants(i).Syllable(ii).Neume(j).Name = k
                            Found = True
                            Exit For
                        End If
                    Next k
                    If Not Found Then
                       MsgBox ("Bad neume name")
                    End If
                    Chants(i).Syllable(ii).Neume(j).NeumeNo = j
                    Input #1, Chants(i).Syllable(ii).Neume(j).Liq
                    Input #1, Chants(i).Syllable(ii).Neume(j).Quil
                    Input #1, Chants(i).Syllable(ii).Neume(j).DetailsType
                    If Chants(i).Syllable(ii).Neume(j).DetailsType > 0 Then
                        Input #1, Chants(i).Syllable(ii).Neume(j).Details
                    Else
                        Input #1, neumstr
                        Select Case Trim(neumstr)
                            Case ""
                                Chants(i).Syllable(ii).Neume(j).Details = 0
                            Case "c"
                                Chants(i).Syllable(ii).Neume(j).Details = 1
                            Case "t"
                                Chants(i).Syllable(ii).Neume(j).Details = 2
                            Case "e"
                                Chants(i).Syllable(ii).Neume(j).Details = 3
                            Case "l"
                                Chants(i).Syllable(ii).Neume(j).Details = 4
                            Case Else
                                Found = False
                                For k = 1 To 15
                                    If neumstr = Details(Chants(i). _
                                    Syllable(ii).Neume(j).Name, k) Then
                                        Chants(i).Syllable(ii).Neume(j). _
                                            Details = k + 4
                                        Found = True
                                        Exit For
                                    End If
                                Next k
                                If Not Found Then
                                    MsgBox ("Bad details")
                                End If
                        End Select
                    End If
                    Input #1, Chants(i).Syllable(ii).Neume(j).PitchDetType
                    Input #1, Chants(i).Syllable(ii).Neume(j).PitchDetails
                    Input #1, Chants(i).Syllable(ii).Neume(j).NumNotes
                    If Chants(i).Syllable(ii).Neume(j).NumNotes > 0 Then
                        ReDim Chants(i).Syllable(ii).Neume(j).Note(1 To _
                            Chants(i).Syllable(ii).Neume(j).NumNotes)
                        For k = 1 To Chants(i).Syllable(ii).Neume(j).NumNotes
                            Chants(i).Syllable(ii).Neume(j).Note(k).NoteNo = k
                            Input #1, neumstr
                            Found = False
                            For kk = 0 To UBound(RelPosTable)
                                If neumstr = RelPosTable(kk) Then
                                    Chants(i).Syllable(ii).Neume(j).Note(k).RelPos = kk
                                    Found = True
                                    Exit For
                                End If
                            Next kk
                            If Not Found Then
                                MsgBox ("Bad relpos")
                            End If
                            Input #1, neumstr
                            ipos = InStr(neumstr, " ")
                            If ipos > 0 Then
                                pitchstr = Right(neumstr, Len(neumstr) - ipos)
                                neumstr = Left(neumstr, ipos - 1)
                                'Debug.Print ipos, neumstr, pitchstr
                            Else
                                pitchstr = ""
                            End If
                            Found = False
                            For kk = 0 To UBound(LongTable)
                                If neumstr = LongTable(kk) Then
                                    Chants(i).Syllable(ii).Neume(j).Note(k).Long = kk
                                    Found = True
                                    Exit For
                                End If
                            Next kk
                            If Not Found Then
                                MsgBox ("Bad long")
                            End If
                            If ipos > 0 Then
                                Chants(i).Syllable(ii).Neume(j).Note(k).Pitch = Asc(pitchstr)
                            End If
                        Next k
                    End If
                Next j
            End If
        Next ii
        Chants(i).Arrays = False
    Next i
    Close #1
    On Error GoTo 0
    NumChants = NumChants + newNumChants
    ThisChant = 1
    ChDir app_dir
    Exit Sub
Errhandler:
    If Err.Number <> cdlCancel Then
        Err.Raise Err.Number
    End If
    ChDir app_dir
End Sub

Public Sub prt_set()
    common.CommonDialog1.CancelError = True
    On Error GoTo Errhandler
    common.CommonDialog1.Flags = 0
'common.CommonDialog1.Flags = cdlPDPrintSetup
  ' use print rather than print setup as don't seem to be able to
  'print to file from print setup box for testing
    common.CommonDialog1.ShowPrinter
    Exit Sub
Errhandler:
    If Err.Number <> cdlCancel Then
        Err.Raise Err.Number
    End If
End Sub

Public Sub print_neume(n As Neume, dest As Object, X As Single, _
   y As Single, fixsize As Boolean, yinc As Single, _
   Optional prtNotes As Boolean = False, Optional EnterNotes As Boolean = False)
Dim savex As Single, savey As Single, i As Integer
Dim detstring As String, pstring As String
Dim savefont As New StdFont, charnbr As Integer, usedLiq As Boolean, _
usedQuil As Boolean
iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
savefont = dest.Font
'do i need a new line or page?

'Debug.Print X, dest.Width, dest.CurrentX, "neu", NeumeTable(n.Name)
If Not fixsize And X > dest.Width - 1000 Then
'Debug.Print X, dest.Width, dest.CurrentX, "neu", NeumeTable(n.Name)
    y = y + yinc
    X = 400
End If
If dest Is Printer And y > 15500 Then
    dest.NewPage
    y = 100
ElseIf Not fixsize And y > dest.Height - 1000 Then
  '  dest.Height = Min(MAXHEIGHT, y + 5000)
End If
savex = dest.CurrentX
savey = dest.CurrentY
dest.Font.Name = chantfont
dest.FontTransparent = True
dest.Font.Size = 12
dest.CurrentX = X
dest.CurrentY = y
iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
' find character number
charnbr = 0
usedLiq = False
usedQuil = False
If n.Liq Then
    charnbr = fontindex(n.Name, -2)
End If
If n.Quil Then
    charnbr = fontindex(n.Name, -1)
End If
If n.Liq And charnbr = fontindex(n.Name, -2) And charnbr <> 0 Then
    usedLiq = True
Else
    If n.Quil And charnbr = fontindex(n.Name, -1) And charnbr <> 0 Then
        usedQuil = True
    End If
End If
If n.DetailsType = 0 And charnbr = 0 Then
    charnbr = fontindex(n.Name, n.Details)
Else
    If Not usedLiq And Not usedQuil Then
        charnbr = 0
    End If
End If
'Debug.Print n.Name, n.Details, charnbr, usedLiq, usedQuil
'Debug.Print dest.CurrentY, "neume";
If charnbr = 0 Then
    charnbr = fontindex(n.Name, 0)
End If
dest.Print Chr(charnbr)
dest.CurrentX = X + 110
If n.Quil And Not usedQuil Then
    dest.Font.Name = "Times New Roman"
    dest.Font.Italic = True
    dest.Font.Size = 6
    dest.CurrentX = X + 100
    dest.CurrentY = y - 100
    iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
    dest.Print "q";
    dest.Font.Name = chantfont
    dest.Font.Italic = False
    dest.Font.Size = 6
End If
If n.Liq And Not usedLiq Then
    dest.Font.Name = "Times New Roman"
    dest.Font.Italic = True
    dest.Font.Size = 6
    dest.CurrentX = X + 100
    dest.CurrentY = y - 100
    iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
    dest.Print "l";
    dest.Font.Name = chantfont
    dest.Font.Italic = False
    dest.Font.Size = 6
End If
getDetails n, detstring, pstring
If charnbr = fontindex(n.Name, 0) Or usedLiq Or usedQuil Then
    If Left(detstring, 2) = "ep" Then
        dest.CurrentY = y - 140
        dest.CurrentX = X + 200
        dest.Font.Size = 10
        iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
        dest.Print "d"; ' a bit of a vertical line
    ElseIf detstring = "joined" Then
        dest.Font.Name = "Times New Roman"
        dest.Font.Italic = True
        dest.Font.Size = 6
        dest.CurrentX = X + 110
        dest.CurrentY = y - 100
        dest.FontTransparent = True
        iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
        dest.Print "j";
    ElseIf Not detstring = "" Then
        dest.Font.Name = "Times New Roman"
        dest.Font.Italic = True
        dest.Font.Size = 6
        If Not n.Quil And Not n.Liq Then
            dest.CurrentX = X + 110
        End If
        dest.CurrentY = y - 100
        iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
        dest.Print detstring;
    End If
End If
If Not pstring = "" Then
    dest.Font.Name = "Times New Roman"
    dest.Font.Italic = True
    dest.Font.Size = 6
    dest.CurrentY = y - 100
    iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
    dest.Print pstring;
End If
dest.Font = savefont
dest.Font.Italic = False
dest.Font.Size = savefont.Size
iBkMode = SetBkMode(dest.hDC, TRANSPARENT)
'print notes
If prtNotes Then
    y = y + 500
    For i = 1 To n.NumNotes
        print_note n.Note(i), dest, X, y, yinc, fixsize, EnterNotes
        X = X + 250
    Next i
    y = y - 500
End If
End Sub
Private Sub print_note(n As Note, dest As Object, X As Single, _
y As Single, yinc As Single, fixsize As Boolean, Optional EnterNotes As Boolean = False)
'do i need a new line or page?
Dim k As Integer
If Not fixsize And X > dest.Width - 700 Then
    y = y + yinc
    X = 400
End If
If dest Is Printer Then
    If y > 16000 Then
        dest.NewPage
        y = 700
    End If
ElseIf Not fixsize And y > dest.Height - 1000 Then
    dest.Height = Min(MAXHEIGHT, y + 5000)
End If
dest.CurrentX = X
dest.CurrentY = y
'Debug.Print dest.CurrentY, "relpos";
dest.Print RelPosTable(n.RelPos)
dest.CurrentX = X
dest.CurrentY = y + 200
'Debug.Print dest.CurrentY, "long"
dest.Print Left(LongTable(n.Long), 1)
dest.CurrentX = X
dest.CurrentY = y + 400
If EnterNotes Then
    k = dest.Text1.UBound + 1
    Load dest.Text1(k)
    dest.Text1(k).Visible = True
    dest.Text1(k).Left = X
    dest.Text1(k).Top = y + 500
    dest.Text1(k).text = Chr(n.Pitch)
Else
    If n.Pitch > 0 Then
        dest.Print Chr(n.Pitch)
    End If
End If
End Sub
Public Sub print_phrase(dest As Object, X As Single, y As Single, p As Phrase, yinc As Single)
Dim i As Integer, newl As Boolean
newl = True
For i = 1 To p.NumSyllables
    print_syllable dest, X, y, p.Syllable(i), newl, yinc
Next i
'set up current line for next verse/phrase number
dest.CurrentY = y + 550
End Sub
Public Sub print_syllable(dest As Object, X As Single, y As Single, _
syl As Syllable, newl As Boolean, yinc As Single)
'do I need a new line? necessary in the print_neume routine too
Dim i As Integer, dum As Single
If X > dest.Width - 1000 Then
    y = y + yinc
    X = 100
    newl = True
End If
If dest Is Printer And y > 15000 Then
    dest.NewPage
    y = 100
ElseIf y > dest.Height - 1000 Then
    dest.Height = Min(MAXHEIGHT, y + 5000)
End If
dest.CurrentY = y + 250
If newl Then
    dest.CurrentX = 10
    dest.Print syl.SyllableNo;
    dest.CurrentX = 400
    X = 400
    newl = False
Else
    dest.CurrentX = X
End If
'Debug.Print X, dest.Width, dest.CurrentX, "syl", syl.Text
dest.Print syl.text
dum = dest.CurrentX
For i = 1 To syl.NumNeumes
   print_neume syl.Neume(i), dest, X, y, False, yinc
   X = X + 400
Next i
If dum < X Then
  X = dum
End If
End Sub
Public Sub rpt1(dest As Object, sing As Boolean, First As Boolean, _
    Last As Boolean, y As Single, Optional prtNotes As Boolean = False)
Dim i As Integer, j As Integer, k As Integer, X As Single, maxx As Long
Dim ii As Integer, iv As Integer, nv As Integer, nn As Integer
Dim l As Integer, yinc As Single, neumenum As Integer, XX As Integer
Dim dumx, dumy As Single
If prtNotes Then
    yinc = 1600
Else
    yinc = 600
End If
If Not dest Is Printer Then
    If sing Or First Then
        dest.Cls
        If sing Then
            dest.Caption = Chants(ThisChant).FullName
        Else
            dest.Caption = ""
            dest.Print Chants(ThisChant).FullName
            dest.Print "======================"
            dest.Print
        End If
        dest.Show
    Else
        dest.Print
        dest.CurrentY = y
        dest.Print Chants(ThisChant).FullName
        dest.Print "====================="
        dest.Print
    End If
Else
    dest.Print
    dest.CurrentY = y
    dest.Font.Name = "Helvetica"
    dest.Print "Chant fullname: "; Chants(ThisChant).FullName
End If
X = 400
y = y + 500
ii = 1
iv = 1
neumenum = 1
If Not dest Is Printer Then
    If sing Or First Then
        With Chants(ThisChant)
            nn = 0
          For i = 1 To .NumSyllables
                nn = nn + .Syllable(i).NumNeumes
            Next i
        End With
        If nn > 0 Then
            isPicx = True
            ReDim pixsel(1 To nn)
            ReDim picn(1 To nn)
            ReDim picx(1 To nn)
            ReDim picy(1 To nn)
        End If
    Else
        With Chants(ThisChant)
            nn = 0
          For i = 1 To .NumSyllables
                nn = nn + .Syllable(i).NumNeumes
            Next i
        End With
        XX = UBound(pixsel)
        ReDim Preserve pixsel(1 To XX + nn)
        ReDim Preserve picn(1 To XX + nn)
        ReDim Preserve picx(1 To XX + nn)
        ReDim Preserve picy(1 To XX + nn)
    End If
End If
For i = 1 To Chants(ThisChant).NumSyllables
    If Chants(ThisChant).Syllable(i).Verse Or X > dest.Width - 1000 Then
        X = 400
      If i > 1 Then
        y = y + yinc
      End If
    End If
    If dest Is Printer Then
        If y > 15000 Then
            dest.NewPage
            y = 100
        End If
    ElseIf y > dest.Height - 1250 Then
            dest.Height = Min(MAXHEIGHT, y + 5000)
    End If
    If Chants(ThisChant).Syllable(i).Verse Then
        dest.CurrentX = 5
        dest.CurrentY = y
        dest.Print "v"; iv;
        dest.CurrentX = 5
        dest.CurrentY = y + 250
        dest.Print neumenum;
        y = y + 250
        dest.CurrentX = 5
        dest.CurrentY = y + 250
        dest.Print i;
        dest.CurrentX = X
        iv = iv + 1
    Else
        If X = 400 Then
            dest.CurrentX = 5
            dest.CurrentY = y
            dest.Print neumenum;
            dest.CurrentX = 5
            dest.CurrentY = y + 250
            dest.Print i;
            dest.CurrentX = X
            If Chants(ThisChant).Syllable(i).Phrase Then
                dest.Print "[";
            End If
        Else
            dest.CurrentY = y + 250
            dest.CurrentX = X
            If Chants(ThisChant).Syllable(i).Phrase Then
                dest.Print "[";
            End If
        End If
    End If
    Debug.Print dest.CurrentY, "text", dest.CurrentX;
    dest.Print Chants(ThisChant).Syllable(i).text;
    dumx = dest.CurrentX
    dumy = y
    For l = 1 To Chants(ThisChant).Syllable(i).NumNeumes
        If X > dest.Width - 1000 Then
            X = 400
            y = y + yinc
            dest.CurrentX = 5
            dest.CurrentY = y
            dest.Print neumenum;
            dest.CurrentX = 5
            dest.CurrentY = y + 250
            dest.Print i;
            dest.CurrentX = X
        End If
        If Not dest Is Printer Then
            picx(XX + ii) = X
            picy(XX + ii) = y
            pixsel(XX + ii) = False
            picn(XX + ii) = Chants(ThisChant).Syllable(i).Neume(l)
            ii = ii + 1
        End If
        print_neume Chants(ThisChant).Syllable(i).Neume(l), dest, X, _
           y, False, yinc, prtNotes
        dest.Print " ";
        neumenum = neumenum + 1
        X = X + 400
    Next l
    If dumy = y And X < dumx Then
        X = dumx + 50
    End If
Next i
If dest Is Printer And Last Then
    dest.EndDoc
End If
End Sub
Public Sub rpt2(dest As Object) ' note entry screen
Dim i As Integer, j As Integer, k As Integer, X As Single, maxx As Long
Dim ii As Integer, iv As Integer, nv As Integer, nn As Integer
Dim l As Integer, yinc As Single, y As Single
yinc = 1600
Unload dest
dest.Cls
dest.Caption = Chants(ThisChant).FullName
dest.Show
X = 400
y = 800
ii = 1
'find current verse and total number of neumes
With Chants(ThisChant)
    For i = 1 To UBound(.clenv)
        If startSyl > .clenv(i - 1) And startSyl <= .clenv(i) Then
            iv = i
            Exit For
        End If
    Next i
    nn = 0
    For i = startSyl To endSyl
        nn = nn + .Syllable(i).NumNeumes
    Next i
End With
If nn = 0 Then
    MsgBox ("No neumes to enter notes for")
    Exit Sub
End If
ReDim picx2(1 To nn)
ReDim picy2(1 To nn)
ReDim picns(1 To nn)
ReDim picnn(1 To nn)
For i = startSyl To endSyl
    If Chants(ThisChant).Syllable(i).Verse Or X > dest.Width - 1000 Then
        X = 400
      If i <> startSyl Then
        y = y + yinc
      End If
    End If
    If y > dest.Height - 1000 Then
            dest.Height = Min(MAXHEIGHT, y + 5000)
    End If
    If Chants(ThisChant).Syllable(i).Verse Or i = startSyl Then
        dest.CurrentX = 5
        dest.CurrentY = y
        dest.Print "V"; iv;
        dest.CurrentX = 5
        dest.CurrentY = y + 250
        dest.Print i;
        dest.CurrentX = X
        iv = iv + 1
    Else
        If X = 400 Then
            dest.CurrentX = 5
            dest.CurrentY = y + 250
            dest.Print i;
            dest.CurrentX = X
            If Chants(ThisChant).Syllable(i).Phrase Then
                dest.Print "[";
            End If
        Else
            dest.CurrentY = y + 250
            dest.CurrentX = X
            If Chants(ThisChant).Syllable(i).Phrase Then
                dest.Print "[";
            End If
        End If
    End If
   ' Debug.Print dest.CurrentY, "text";
    dest.Print Chants(ThisChant).Syllable(i).text
    For l = 1 To Chants(ThisChant).Syllable(i).NumNeumes
        If X > dest.Width - 1000 Then
            X = 400
            y = y + yinc
        End If
        picx2(ii) = X
        picy2(ii) = y
        picns(ii) = i
        picnn(ii) = l
        ii = ii + 1
        print_neume Chants(ThisChant).Syllable(i).Neume(l), dest, X, _
           y, False, yinc, True, True
        X = X + 400
    Next l
Next i
End Sub
Public Sub write_chants(saveAs As Boolean)
Dim ii As Integer, i As Integer, j As Integer, k As Integer
If saveAs Or common.CommonDialog1.FileName = "" Or thisfilename = "" Then
On Error GoTo Errhandler
common.CommonDialog1.InitDir = home_dir
common.CommonDialog1.Filter = "Chant files (*.cht)|*.cht|Any files|*.*"
common.CommonDialog1.ShowSave
Else
common.CommonDialog1.FileName = thisfilename
End If
Open common.CommonDialog1.FileName For Output As #2
Write #2, NumChants
For ii = 1 To NumChants
    Write #2, Chants(ii).FullName
    Write #2, Chants(ii).ShortName
    Write #2, Chants(ii).NumSyllables
    For i = 1 To Chants(ii).NumSyllables
        Write #2, Chants(ii).Syllable(i).text
        Write #2, Chants(ii).Syllable(i).Verse
        Write #2, Chants(ii).Syllable(i).Phrase
        Write #2, Chants(ii).Syllable(i).NumNeumes
        For j = 1 To Chants(ii).Syllable(i).NumNeumes
            Write #2, NeumeTable(Chants(ii).Syllable(i).Neume(j).Name)
            Write #2, Chants(ii).Syllable(i).Neume(j).Liq
            Write #2, Chants(ii).Syllable(i).Neume(j).Quil
            Write #2, Chants(ii).Syllable(i).Neume(j).DetailsType
            If Chants(ii).Syllable(i).Neume(j).DetailsType > 0 Then
                Write #2, Chants(ii).Syllable(i).Neume(j).Details
            Else
                Select Case Chants(ii).Syllable(i).Neume(j).Details
                    Case 0
                        Write #2, ""
                    Case 1
                        Write #2, "c"
                    Case 2
                        Write #2, "t"
                    Case 3
                        Write #2, "e"
                    Case 4
                        Write #2, "l"
                    Case Else
                        Write #2, Details(Chants(ii).Syllable(i).Neume(j).Name, _
                            Chants(ii).Syllable(i).Neume(j).Details - 4)
                End Select
            End If
            Write #2, Chants(ii).Syllable(i).Neume(j).PitchDetType
            Write #2, Chants(ii).Syllable(i).Neume(j).PitchDetails
            Write #2, Chants(ii).Syllable(i).Neume(j).NumNotes
            For k = 1 To Chants(ii).Syllable(i).Neume(j).NumNotes
                Write #2, RelPosTable(Chants(ii).Syllable(i).Neume(j).Note(k).RelPos)
                If Chants(ii).Syllable(i).Neume(j).Note(k).Pitch <> 0 Then
                    Write #2, LongTable(Chants(ii).Syllable(i).Neume(j).Note(k).Long) + Chr(Chants(ii).Syllable(i).Neume(j).Note(k).Pitch)
                Else
                    Write #2, LongTable(Chants(ii).Syllable(i).Neume(j).Note(k).Long)
                End If
            Next k
        Next j
    Next
Next ii
Close #2
ChDir app_dir
Exit Sub
Errhandler:
    If Err.Number <> cdlCancel Then
        Err.Raise Err.Number
    End If
    ChDir app_dir
End Sub
Public Sub Logfile(Message As String)
Dim Logfile As Integer
Logfile = FreeFile
Open home_dir + "\Logfile1.log" For Append As #Logfile
Print #Logfile, Message
Close #Logfile
End Sub
Public Sub prtCheck(dest As Object, ByVal fixsize As Boolean, _
    X As Single, y As Single, ByVal yinc As Integer, _
    ByVal newy As Single, newl As Boolean, ByVal xnec As Single, _
    ByVal ynec As Single, ByVal newx As Single)
newl = False
If Not fixsize And X > dest.Width - xnec Then
    y = y + yinc
    X = newx
    newl = True
End If
If dest Is Printer And y > PAPERHEIGHT - ynec Then
'Debug.Print ynec, y, dest.CurrentY
    dest.NewPage
    y = newy
    newl = True
    X = newx
ElseIf Not fixsize And y > dest.Height - ynec Then
    dest.Height = Min(MAXHEIGHT, y + 5000)
End If
'Debug.Print dest.Height, y, ynec
End Sub
